Package org.eclipse.lemminx.extensions.references.search

## Class SearchQueryFactory

- java.lang.Object
- - org.eclipse.lemminx.extensions.references.search.SearchQueryFactory

    public class SearchQueryFactory
    extends Object

XML references search Query factory.

Author:
  Angelo ZERR

### Constructor Summary

Constructors
`SearchQueryFactory()`

### Method Summary

All Methods Static Methods Concrete Methods
`static SearchQuery` `createFromQuery​(DOMNode node, int offset, XMLReferencesSettings settings)`
`static SearchQuery` `createQuery​(DOMNode node, int offset, XMLReferencesSettings settings)`
`static SearchQuery` `createQuery​(DOMNode node, int offset, XMLReferencesSettings settings, SearchQuery.QueryDirection direction)`
`static SearchQuery` `createQuery​(DOMNode node, XMLReferencesSettings settings, SearchQuery.QueryDirection direction)`
`static SearchQuery` `createToQuery​(DOMNode node, int offset, XMLReferencesSettings settings)`
`static SearchQuery` `createToQueryByRetrievingToBefore​(DOMNode node, int offset, XMLReferencesSettings settings, org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)`
`static SearchNode.Direction` `getDirection​(DOMNode node, XMLReferenceExpression expression, SearchQuery.QueryDirection queryDirection)` Returns the direction of the given node according the given expression and query direction.
`static SearchNode.Direction` `getInversedDirection​(DOMNode node, XMLReferenceExpression expression, SearchQuery.QueryDirection direction)` Returns the inversed direction of the given node according the given expression and query direction.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### SearchQueryFactory

    public SearchQueryFactory()

### Method Detail

#### getInversedDirection

    public static SearchNode.Direction getInversedDirection​(DOMNode node,
                                                            XMLReferenceExpression expression,
                                                            SearchQuery.QueryDirection direction)

Returns the inversed direction of the given node according the given expression and query direction.

Parameters:
  `node` - the DOM node.
  `expression` - the reference expression.
  `queryDirection` - the query direction.
Returns:
  the inversed direction of the given node according the given expression and query direction.

#### getDirection

    public static SearchNode.Direction getDirection​(DOMNode node,
                                                    XMLReferenceExpression expression,
                                                    SearchQuery.QueryDirection queryDirection)

Returns the direction of the given node according the given expression and query direction.

Parameters:
  `node` - the DOM node.
  `expression` - the reference expression.
  `queryDirection` - the query direction.
Returns:
  the direction of the given node according the given expression and query direction.

#### createQuery

    public static SearchQuery createQuery​(DOMNode node,
                                          int offset,
                                          XMLReferencesSettings settings)

#### createFromQuery

    public static SearchQuery createFromQuery​(DOMNode node,
                                              int offset,
                                              XMLReferencesSettings settings)

#### createToQuery

    public static SearchQuery createToQuery​(DOMNode node,
                                            int offset,
                                            XMLReferencesSettings settings)

#### createToQueryByRetrievingToBefore

    public static SearchQuery createToQueryByRetrievingToBefore​(DOMNode node,
                                                                int offset,
                                                                XMLReferencesSettings settings,
                                                                org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)

#### createQuery

    public static SearchQuery createQuery​(DOMNode node,
                                          XMLReferencesSettings settings,
                                          SearchQuery.QueryDirection direction)

#### createQuery

    public static SearchQuery createQuery​(DOMNode node,
                                          int offset,
                                          XMLReferencesSettings settings,
                                          SearchQuery.QueryDirection direction)